<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDirectorReportResponseBase ArrayType
 * @subpackage Arrays
 */
class ArrayOfDirectorReportResponseBase extends AbstractStructArrayBase
{
    /**
     * The DirectorReportResponseBase
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DirectorReportResponseBase[]
     */
    public $DirectorReportResponseBase;
    /**
     * Constructor method for ArrayOfDirectorReportResponseBase
     * @uses ArrayOfDirectorReportResponseBase::setDirectorReportResponseBase()
     * @param \StructType\DirectorReportResponseBase[] $directorReportResponseBase
     */
    public function __construct(array $directorReportResponseBase = array())
    {
        $this
            ->setDirectorReportResponseBase($directorReportResponseBase);
    }
    /**
     * Get DirectorReportResponseBase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DirectorReportResponseBase[]|null
     */
    public function getDirectorReportResponseBase()
    {
        return isset($this->DirectorReportResponseBase) ? $this->DirectorReportResponseBase : null;
    }
    /**
     * Set DirectorReportResponseBase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DirectorReportResponseBase[] $directorReportResponseBase
     * @return \ArrayType\ArrayOfDirectorReportResponseBase
     */
    public function setDirectorReportResponseBase(array $directorReportResponseBase = array())
    {
        foreach ($directorReportResponseBase as $arrayOfDirectorReportResponseBaseDirectorReportResponseBaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfDirectorReportResponseBaseDirectorReportResponseBaseItem instanceof \StructType\DirectorReportResponseBase) {
                throw new \InvalidArgumentException(sprintf('The DirectorReportResponseBase property can only contain items of \StructType\DirectorReportResponseBase, "%s" given', is_object($arrayOfDirectorReportResponseBaseDirectorReportResponseBaseItem) ? get_class($arrayOfDirectorReportResponseBaseDirectorReportResponseBaseItem) : gettype($arrayOfDirectorReportResponseBaseDirectorReportResponseBaseItem)), __LINE__);
            }
        }
        if (is_null($directorReportResponseBase) || (is_array($directorReportResponseBase) && empty($directorReportResponseBase))) {
            unset($this->DirectorReportResponseBase);
        } else {
            $this->DirectorReportResponseBase = $directorReportResponseBase;
        }
        return $this;
    }
    /**
     * Add item to DirectorReportResponseBase value
     * @throws \InvalidArgumentException
     * @param \StructType\DirectorReportResponseBase $item
     * @return \ArrayType\ArrayOfDirectorReportResponseBase
     */
    public function addToDirectorReportResponseBase(\StructType\DirectorReportResponseBase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DirectorReportResponseBase) {
            throw new \InvalidArgumentException(sprintf('The DirectorReportResponseBase property can only contain items of \StructType\DirectorReportResponseBase, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DirectorReportResponseBase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DirectorReportResponseBase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DirectorReportResponseBase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DirectorReportResponseBase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DirectorReportResponseBase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DirectorReportResponseBase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DirectorReportResponseBase
     */
    public function getAttributeName()
    {
        return 'DirectorReportResponseBase';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDirectorReportResponseBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
