<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNaturalUberLink ArrayType
 * @subpackage Arrays
 */
class ArrayOfNaturalUberLink extends AbstractStructArrayBase
{
    /**
     * The NaturalUberLink
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NaturalUberLink[]
     */
    public $NaturalUberLink;
    /**
     * Constructor method for ArrayOfNaturalUberLink
     * @uses ArrayOfNaturalUberLink::setNaturalUberLink()
     * @param \StructType\NaturalUberLink[] $naturalUberLink
     */
    public function __construct(array $naturalUberLink = array())
    {
        $this
            ->setNaturalUberLink($naturalUberLink);
    }
    /**
     * Get NaturalUberLink value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NaturalUberLink[]|null
     */
    public function getNaturalUberLink()
    {
        return isset($this->NaturalUberLink) ? $this->NaturalUberLink : null;
    }
    /**
     * Set NaturalUberLink value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\NaturalUberLink[] $naturalUberLink
     * @return \ArrayType\ArrayOfNaturalUberLink
     */
    public function setNaturalUberLink(array $naturalUberLink = array())
    {
        foreach ($naturalUberLink as $arrayOfNaturalUberLinkNaturalUberLinkItem) {
            // validation for constraint: itemType
            if (!$arrayOfNaturalUberLinkNaturalUberLinkItem instanceof \StructType\NaturalUberLink) {
                throw new \InvalidArgumentException(sprintf('The NaturalUberLink property can only contain items of \StructType\NaturalUberLink, "%s" given', is_object($arrayOfNaturalUberLinkNaturalUberLinkItem) ? get_class($arrayOfNaturalUberLinkNaturalUberLinkItem) : gettype($arrayOfNaturalUberLinkNaturalUberLinkItem)), __LINE__);
            }
        }
        if (is_null($naturalUberLink) || (is_array($naturalUberLink) && empty($naturalUberLink))) {
            unset($this->NaturalUberLink);
        } else {
            $this->NaturalUberLink = $naturalUberLink;
        }
        return $this;
    }
    /**
     * Add item to NaturalUberLink value
     * @throws \InvalidArgumentException
     * @param \StructType\NaturalUberLink $item
     * @return \ArrayType\ArrayOfNaturalUberLink
     */
    public function addToNaturalUberLink(\StructType\NaturalUberLink $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NaturalUberLink) {
            throw new \InvalidArgumentException(sprintf('The NaturalUberLink property can only contain items of \StructType\NaturalUberLink, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->NaturalUberLink[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\NaturalUberLink|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\NaturalUberLink|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\NaturalUberLink|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\NaturalUberLink|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\NaturalUberLink|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NaturalUberLink
     */
    public function getAttributeName()
    {
        return 'NaturalUberLink';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNaturalUberLink
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
