<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOtherPossibleMatch ArrayType
 * @subpackage Arrays
 */
class ArrayOfOtherPossibleMatch extends AbstractStructArrayBase
{
    /**
     * The OtherPossibleMatch
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OtherPossibleMatch[]
     */
    public $OtherPossibleMatch;
    /**
     * Constructor method for ArrayOfOtherPossibleMatch
     * @uses ArrayOfOtherPossibleMatch::setOtherPossibleMatch()
     * @param \StructType\OtherPossibleMatch[] $otherPossibleMatch
     */
    public function __construct(array $otherPossibleMatch = array())
    {
        $this
            ->setOtherPossibleMatch($otherPossibleMatch);
    }
    /**
     * Get OtherPossibleMatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OtherPossibleMatch[]|null
     */
    public function getOtherPossibleMatch()
    {
        return isset($this->OtherPossibleMatch) ? $this->OtherPossibleMatch : null;
    }
    /**
     * Set OtherPossibleMatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OtherPossibleMatch[] $otherPossibleMatch
     * @return \ArrayType\ArrayOfOtherPossibleMatch
     */
    public function setOtherPossibleMatch(array $otherPossibleMatch = array())
    {
        foreach ($otherPossibleMatch as $arrayOfOtherPossibleMatchOtherPossibleMatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfOtherPossibleMatchOtherPossibleMatchItem instanceof \StructType\OtherPossibleMatch) {
                throw new \InvalidArgumentException(sprintf('The OtherPossibleMatch property can only contain items of \StructType\OtherPossibleMatch, "%s" given', is_object($arrayOfOtherPossibleMatchOtherPossibleMatchItem) ? get_class($arrayOfOtherPossibleMatchOtherPossibleMatchItem) : gettype($arrayOfOtherPossibleMatchOtherPossibleMatchItem)), __LINE__);
            }
        }
        if (is_null($otherPossibleMatch) || (is_array($otherPossibleMatch) && empty($otherPossibleMatch))) {
            unset($this->OtherPossibleMatch);
        } else {
            $this->OtherPossibleMatch = $otherPossibleMatch;
        }
        return $this;
    }
    /**
     * Add item to OtherPossibleMatch value
     * @throws \InvalidArgumentException
     * @param \StructType\OtherPossibleMatch $item
     * @return \ArrayType\ArrayOfOtherPossibleMatch
     */
    public function addToOtherPossibleMatch(\StructType\OtherPossibleMatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OtherPossibleMatch) {
            throw new \InvalidArgumentException(sprintf('The OtherPossibleMatch property can only contain items of \StructType\OtherPossibleMatch, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OtherPossibleMatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OtherPossibleMatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OtherPossibleMatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OtherPossibleMatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OtherPossibleMatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OtherPossibleMatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OtherPossibleMatch
     */
    public function getAttributeName()
    {
        return 'OtherPossibleMatch';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOtherPossibleMatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
