<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrintoutImage ArrayType
 * @subpackage Arrays
 */
class ArrayOfPrintoutImage extends AbstractStructArrayBase
{
    /**
     * The PrintoutImage
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PrintoutImage[]
     */
    public $PrintoutImage;
    /**
     * Constructor method for ArrayOfPrintoutImage
     * @uses ArrayOfPrintoutImage::setPrintoutImage()
     * @param \StructType\PrintoutImage[] $printoutImage
     */
    public function __construct(array $printoutImage = array())
    {
        $this
            ->setPrintoutImage($printoutImage);
    }
    /**
     * Get PrintoutImage value
     * @return \StructType\PrintoutImage[]|null
     */
    public function getPrintoutImage()
    {
        return $this->PrintoutImage;
    }
    /**
     * Set PrintoutImage value
     * @throws \InvalidArgumentException
     * @param \StructType\PrintoutImage[] $printoutImage
     * @return \ArrayType\ArrayOfPrintoutImage
     */
    public function setPrintoutImage(array $printoutImage = array())
    {
        foreach ($printoutImage as $arrayOfPrintoutImagePrintoutImageItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrintoutImagePrintoutImageItem instanceof \StructType\PrintoutImage) {
                throw new \InvalidArgumentException(sprintf('The PrintoutImage property can only contain items of \StructType\PrintoutImage, "%s" given', is_object($arrayOfPrintoutImagePrintoutImageItem) ? get_class($arrayOfPrintoutImagePrintoutImageItem) : gettype($arrayOfPrintoutImagePrintoutImageItem)), __LINE__);
            }
        }
        $this->PrintoutImage = $printoutImage;
        return $this;
    }
    /**
     * Add item to PrintoutImage value
     * @throws \InvalidArgumentException
     * @param \StructType\PrintoutImage $item
     * @return \ArrayType\ArrayOfPrintoutImage
     */
    public function addToPrintoutImage(\StructType\PrintoutImage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PrintoutImage) {
            throw new \InvalidArgumentException(sprintf('The PrintoutImage property can only contain items of \StructType\PrintoutImage, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PrintoutImage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PrintoutImage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PrintoutImage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PrintoutImage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PrintoutImage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PrintoutImage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PrintoutImage
     */
    public function getAttributeName()
    {
        return 'PrintoutImage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPrintoutImage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
