<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUberLinkBase ArrayType
 * @subpackage Arrays
 */
class ArrayOfUberLinkBase extends AbstractStructArrayBase
{
    /**
     * The UberLinkBase
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UberLinkBase[]
     */
    public $UberLinkBase;
    /**
     * Constructor method for ArrayOfUberLinkBase
     * @uses ArrayOfUberLinkBase::setUberLinkBase()
     * @param \StructType\UberLinkBase[] $uberLinkBase
     */
    public function __construct(array $uberLinkBase = array())
    {
        $this
            ->setUberLinkBase($uberLinkBase);
    }
    /**
     * Get UberLinkBase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UberLinkBase[]|null
     */
    public function getUberLinkBase()
    {
        return isset($this->UberLinkBase) ? $this->UberLinkBase : null;
    }
    /**
     * Set UberLinkBase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UberLinkBase[] $uberLinkBase
     * @return \ArrayType\ArrayOfUberLinkBase
     */
    public function setUberLinkBase(array $uberLinkBase = array())
    {
        foreach ($uberLinkBase as $arrayOfUberLinkBaseUberLinkBaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfUberLinkBaseUberLinkBaseItem instanceof \StructType\UberLinkBase) {
                throw new \InvalidArgumentException(sprintf('The UberLinkBase property can only contain items of \StructType\UberLinkBase, "%s" given', is_object($arrayOfUberLinkBaseUberLinkBaseItem) ? get_class($arrayOfUberLinkBaseUberLinkBaseItem) : gettype($arrayOfUberLinkBaseUberLinkBaseItem)), __LINE__);
            }
        }
        if (is_null($uberLinkBase) || (is_array($uberLinkBase) && empty($uberLinkBase))) {
            unset($this->UberLinkBase);
        } else {
            $this->UberLinkBase = $uberLinkBase;
        }
        return $this;
    }
    /**
     * Add item to UberLinkBase value
     * @throws \InvalidArgumentException
     * @param \StructType\UberLinkBase $item
     * @return \ArrayType\ArrayOfUberLinkBase
     */
    public function addToUberLinkBase(\StructType\UberLinkBase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UberLinkBase) {
            throw new \InvalidArgumentException(sprintf('The UberLinkBase property can only contain items of \StructType\UberLinkBase, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UberLinkBase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UberLinkBase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UberLinkBase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UberLinkBase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UberLinkBase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UberLinkBase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UberLinkBase
     */
    public function getAttributeName()
    {
        return 'UberLinkBase';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUberLinkBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
