<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CheckCreditLimitForBatchSearch' => '\\StructType\\CheckCreditLimitForBatchSearch',
            'CheckCreditLimitForBatchSearchResponse' => '\\StructType\\CheckCreditLimitForBatchSearchResponse',
            'CreditCheckResponse' => '\\StructType\\CreditCheckResponse',
            'EmailCredentials' => '\\StructType\\EmailCredentials',
            'TokenCredentials' => '\\StructType\\TokenCredentials',
            'WinDeedCredentials' => '\\StructType\\WinDeedCredentials',
            'RetrieveSearchResult' => '\\StructType\\RetrieveSearchResult',
            'RetrieveSearchResultResponse' => '\\StructType\\RetrieveSearchResultResponse',
            'CipcUberSearchResult' => '\\StructType\\CipcUberSearchResult',
            'RequestBase' => '\\StructType\\RequestBase',
            'DirectorRequest' => '\\StructType\\DirectorRequest',
            'DirectorDbKeyRequest' => '\\StructType\\DirectorDbKeyRequest',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'CompanyDbKeyRequest' => '\\StructType\\CompanyDbKeyRequest',
            'CompanyRequest' => '\\StructType\\CompanyRequest',
            'CompanyByRegistrationNumberRequest' => '\\StructType\\CompanyByRegistrationNumberRequest',
            'CompanyByNameRequest' => '\\StructType\\CompanyByNameRequest',
            'CompanyListResponse' => '\\StructType\\CompanyListResponse',
            'ArrayOfCompanyListItem' => '\\ArrayType\\ArrayOfCompanyListItem',
            'JuristicUberLink' => '\\StructType\\JuristicUberLink',
            'NaturalUberLink' => '\\StructType\\NaturalUberLink',
            'CompanyResponse' => '\\StructType\\CompanyResponse',
            'ArrayOfCompanyReport' => '\\ArrayType\\ArrayOfCompanyReport',
            'CompanyReport' => '\\StructType\\CompanyReport',
            'AuditorProfession' => '\\StructType\\AuditorProfession',
            'ArrayOfMemberBase' => '\\ArrayType\\ArrayOfMemberBase',
            'JuristicMember' => '\\StructType\\JuristicMember',
            'NaturalMember' => '\\StructType\\NaturalMember',
            'ArrayOfNaturalUberLink' => '\\ArrayType\\ArrayOfNaturalUberLink',
            'ArrayOfAuditor' => '\\ArrayType\\ArrayOfAuditor',
            'ArrayOfCapital' => '\\ArrayType\\ArrayOfCapital',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'ErrorResponse' => '\\StructType\\ErrorResponse',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'DirectorResponse' => '\\StructType\\DirectorResponse',
            'ArrayOfDirectorReportResponseBase' => '\\ArrayType\\ArrayOfDirectorReportResponseBase',
            'JuristicDirectorReportResponse' => '\\StructType\\JuristicDirectorReportResponse',
            'NaturalDirectorReportResponse' => '\\StructType\\NaturalDirectorReportResponse',
            'ArrayOfOtherPossibleMatch' => '\\ArrayType\\ArrayOfOtherPossibleMatch',
            'EulaResponse' => '\\StructType\\EulaResponse',
            'DirectorListResponse' => '\\StructType\\DirectorListResponse',
            'ArrayOfDirectorListItem' => '\\ArrayType\\ArrayOfDirectorListItem',
            'TooManyResultsResponseBase' => '\\StructType\\TooManyResultsResponseBase',
            'DirectorTooManyResultsResponse' => '\\StructType\\DirectorTooManyResultsResponse',
            'CompanyTooManyResultsResponse' => '\\StructType\\CompanyTooManyResultsResponse',
            'NotFoundResponseBase' => '\\StructType\\NotFoundResponseBase',
            'DirectorNotFoundResponse' => '\\StructType\\DirectorNotFoundResponse',
            'CompanyNotFoundResponse' => '\\StructType\\CompanyNotFoundResponse',
            'RetrieveSearchRequest' => '\\StructType\\RetrieveSearchRequest',
            'RetrieveSearchRequestResponse' => '\\StructType\\RetrieveSearchRequestResponse',
            'CipcUberSearchRequest' => '\\StructType\\CipcUberSearchRequest',
            'PlaceRequest' => '\\StructType\\PlaceRequest',
            'PlaceRequestResponse' => '\\StructType\\PlaceRequestResponse',
            'RetrieveResponse' => '\\StructType\\RetrieveResponse',
            'RetrieveResponseResponse' => '\\StructType\\RetrieveResponseResponse',
            'PeekResponse' => '\\StructType\\PeekResponse',
            'PeekResponseResponse' => '\\StructType\\PeekResponseResponse',
            'RequestCompleted' => '\\StructType\\RequestCompleted',
            'RequestCompletedResponse' => '\\StructType\\RequestCompletedResponse',
            'RetrieveOldResponse' => '\\StructType\\RetrieveOldResponse',
            'RetrieveOldResponseResponse' => '\\StructType\\RetrieveOldResponseResponse',
            'RetrieveOldRequest' => '\\StructType\\RetrieveOldRequest',
            'RetrieveOldRequestResponse' => '\\StructType\\RetrieveOldRequestResponse',
            'RequestPrintout' => '\\StructType\\RequestPrintout',
            'PrintoutRequest' => '\\StructType\\PrintoutRequest',
            'RequestPrintoutResponse' => '\\StructType\\RequestPrintoutResponse',
            'PrintoutResponse' => '\\StructType\\PrintoutResponse',
            'HtmlPrintoutResponse' => '\\StructType\\HtmlPrintoutResponse',
            'ArrayOfPrintoutImage' => '\\ArrayType\\ArrayOfPrintoutImage',
            'PrintoutImage' => '\\StructType\\PrintoutImage',
            'RequestPrintoutWithStamp' => '\\StructType\\RequestPrintoutWithStamp',
            'RequestPrintoutWithStampResponse' => '\\StructType\\RequestPrintoutWithStampResponse',
            'Authenticate' => '\\StructType\\Authenticate',
            'AuthenticateResponse' => '\\StructType\\AuthenticateResponse',
            'ChangePassword' => '\\StructType\\ChangePassword',
            'ChangePasswordResponse' => '\\StructType\\ChangePasswordResponse',
            'RequestPasswordChange' => '\\StructType\\RequestPasswordChange',
            'RequestPasswordChangeResponse' => '\\StructType\\RequestPasswordChangeResponse',
            'PasswordActivationKeyIsValid' => '\\StructType\\PasswordActivationKeyIsValid',
            'PasswordActivationKeyIsValidResponse' => '\\StructType\\PasswordActivationKeyIsValidResponse',
            'SetPassword' => '\\StructType\\SetPassword',
            'SetPasswordResponse' => '\\StructType\\SetPasswordResponse',
            'ResetPassword' => '\\StructType\\ResetPassword',
            'ResetPasswordResponse' => '\\StructType\\ResetPasswordResponse',
            'CheckCredentials' => '\\StructType\\CheckCredentials',
            'CheckCredentialsResponse' => '\\StructType\\CheckCredentialsResponse',
            'ResponseBase' => '\\StructType\\ResponseBase',
            'CompanyListItem' => '\\StructType\\CompanyListItem',
            'ListItemBase' => '\\StructType\\ListItemBase',
            'DirectorListItem' => '\\StructType\\DirectorListItem',
            'ArrayOfUberLinkBase' => '\\ArrayType\\ArrayOfUberLinkBase',
            'UberLinkBase' => '\\StructType\\UberLinkBase',
            'RegistrationNumber' => '\\StructType\\RegistrationNumber',
            'CompanyInformation' => '\\StructType\\CompanyInformation',
            'CipcLookup' => '\\StructType\\CipcLookup',
            'BasicAddress' => '\\StructType\\BasicAddress',
            'Financials' => '\\StructType\\Financials',
            'MemberBase' => '\\StructType\\MemberBase',
            'Auditor' => '\\StructType\\Auditor',
            'Capital' => '\\StructType\\Capital',
            'History' => '\\StructType\\History',
            'DirectorReportResponseBase' => '\\StructType\\DirectorReportResponseBase',
            'ArrayOfAssociatedCompany' => '\\ArrayType\\ArrayOfAssociatedCompany',
            'AssociatedCompany' => '\\StructType\\AssociatedCompany',
            'OtherPossibleMatch' => '\\StructType\\OtherPossibleMatch',
        );
    }
}
