<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthenticateResponse StructType
 * @subpackage Structs
 */
class AuthenticateResponse extends AbstractStructBase
{
    /**
     * The AuthenticateResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $AuthenticateResult;
    /**
     * Constructor method for AuthenticateResponse
     * @uses AuthenticateResponse::setAuthenticateResult()
     * @param bool $authenticateResult
     */
    public function __construct($authenticateResult = null)
    {
        $this
            ->setAuthenticateResult($authenticateResult);
    }
    /**
     * Get AuthenticateResult value
     * @return bool
     */
    public function getAuthenticateResult()
    {
        return $this->AuthenticateResult;
    }
    /**
     * Set AuthenticateResult value
     * @param bool $authenticateResult
     * @return \StructType\AuthenticateResponse
     */
    public function setAuthenticateResult($authenticateResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($authenticateResult) && !is_bool($authenticateResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($authenticateResult)), __LINE__);
        }
        $this->AuthenticateResult = $authenticateResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AuthenticateResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
