<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DirectorListItem StructType
 * @subpackage Structs
 */
class DirectorListItem extends ListItemBase
{
    /**
     * The IsSingleton
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsSingleton;
    /**
     * The UberLinks
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfUberLinkBase
     */
    public $UberLinks;
    /**
     * Constructor method for DirectorListItem
     * @uses DirectorListItem::setIsSingleton()
     * @uses DirectorListItem::setUberLinks()
     * @param bool $isSingleton
     * @param \ArrayType\ArrayOfUberLinkBase $uberLinks
     */
    public function __construct($isSingleton = null, \ArrayType\ArrayOfUberLinkBase $uberLinks = null)
    {
        $this
            ->setIsSingleton($isSingleton)
            ->setUberLinks($uberLinks);
    }
    /**
     * Get IsSingleton value
     * @return bool
     */
    public function getIsSingleton()
    {
        return $this->IsSingleton;
    }
    /**
     * Set IsSingleton value
     * @param bool $isSingleton
     * @return \StructType\DirectorListItem
     */
    public function setIsSingleton($isSingleton = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSingleton) && !is_bool($isSingleton)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isSingleton)), __LINE__);
        }
        $this->IsSingleton = $isSingleton;
        return $this;
    }
    /**
     * Get UberLinks value
     * @return \ArrayType\ArrayOfUberLinkBase|null
     */
    public function getUberLinks()
    {
        return $this->UberLinks;
    }
    /**
     * Set UberLinks value
     * @param \ArrayType\ArrayOfUberLinkBase $uberLinks
     * @return \StructType\DirectorListItem
     */
    public function setUberLinks(\ArrayType\ArrayOfUberLinkBase $uberLinks = null)
    {
        $this->UberLinks = $uberLinks;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DirectorListItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
