<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JuristicMember StructType
 * @subpackage Structs
 */
class JuristicMember extends MemberBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The RegistrationNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RegistrationNumber
     */
    public $RegistrationNumber;
    /**
     * Constructor method for JuristicMember
     * @uses JuristicMember::setName()
     * @uses JuristicMember::setRegistrationNumber()
     * @param string $name
     * @param \StructType\RegistrationNumber $registrationNumber
     */
    public function __construct($name = null, \StructType\RegistrationNumber $registrationNumber = null)
    {
        $this
            ->setName($name)
            ->setRegistrationNumber($registrationNumber);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JuristicMember
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get RegistrationNumber value
     * @return \StructType\RegistrationNumber|null
     */
    public function getRegistrationNumber()
    {
        return $this->RegistrationNumber;
    }
    /**
     * Set RegistrationNumber value
     * @param \StructType\RegistrationNumber $registrationNumber
     * @return \StructType\JuristicMember
     */
    public function setRegistrationNumber(\StructType\RegistrationNumber $registrationNumber = null)
    {
        $this->RegistrationNumber = $registrationNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JuristicMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
