<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NaturalDirectorReportResponse StructType
 * @subpackage Structs
 */
class NaturalDirectorReportResponse extends DirectorReportResponseBase
{
    /**
     * The DateOfBirth
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DateOfBirth;
    /**
     * The FirstName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FirstName;
    /**
     * The LastName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastName;
    /**
     * The IdNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IdNumber;
    /**
     * The MaidenName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MaidenName;
    /**
     * The SurnameParticular
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurnameParticular;
    /**
     * Constructor method for NaturalDirectorReportResponse
     * @uses NaturalDirectorReportResponse::setDateOfBirth()
     * @uses NaturalDirectorReportResponse::setFirstName()
     * @uses NaturalDirectorReportResponse::setLastName()
     * @uses NaturalDirectorReportResponse::setIdNumber()
     * @uses NaturalDirectorReportResponse::setMaidenName()
     * @uses NaturalDirectorReportResponse::setSurnameParticular()
     * @param string $dateOfBirth
     * @param string $firstName
     * @param string $lastName
     * @param string $idNumber
     * @param string $maidenName
     * @param string $surnameParticular
     */
    public function __construct($dateOfBirth = null, $firstName = null, $lastName = null, $idNumber = null, $maidenName = null, $surnameParticular = null)
    {
        $this
            ->setDateOfBirth($dateOfBirth)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setIdNumber($idNumber)
            ->setMaidenName($maidenName)
            ->setSurnameParticular($surnameParticular);
    }
    /**
     * Get DateOfBirth value
     * @return string
     */
    public function getDateOfBirth()
    {
        return $this->DateOfBirth;
    }
    /**
     * Set DateOfBirth value
     * @param string $dateOfBirth
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setDateOfBirth($dateOfBirth = null)
    {
        // validation for constraint: string
        if (!is_null($dateOfBirth) && !is_string($dateOfBirth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateOfBirth)), __LINE__);
        }
        $this->DateOfBirth = $dateOfBirth;
        return $this;
    }
    /**
     * Get FirstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get LastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get IdNumber value
     * @return string|null
     */
    public function getIdNumber()
    {
        return $this->IdNumber;
    }
    /**
     * Set IdNumber value
     * @param string $idNumber
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setIdNumber($idNumber = null)
    {
        // validation for constraint: string
        if (!is_null($idNumber) && !is_string($idNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idNumber)), __LINE__);
        }
        $this->IdNumber = $idNumber;
        return $this;
    }
    /**
     * Get MaidenName value
     * @return string|null
     */
    public function getMaidenName()
    {
        return $this->MaidenName;
    }
    /**
     * Set MaidenName value
     * @param string $maidenName
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setMaidenName($maidenName = null)
    {
        // validation for constraint: string
        if (!is_null($maidenName) && !is_string($maidenName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maidenName)), __LINE__);
        }
        $this->MaidenName = $maidenName;
        return $this;
    }
    /**
     * Get SurnameParticular value
     * @return string|null
     */
    public function getSurnameParticular()
    {
        return $this->SurnameParticular;
    }
    /**
     * Set SurnameParticular value
     * @param string $surnameParticular
     * @return \StructType\NaturalDirectorReportResponse
     */
    public function setSurnameParticular($surnameParticular = null)
    {
        // validation for constraint: string
        if (!is_null($surnameParticular) && !is_string($surnameParticular)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($surnameParticular)), __LINE__);
        }
        $this->SurnameParticular = $surnameParticular;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NaturalDirectorReportResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
