<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegistrationNumber StructType
 * @subpackage Structs
 */
class RegistrationNumber extends AbstractStructBase
{
    /**
     * The Prefix
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Prefix;
    /**
     * The UniqueRegNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UniqueRegNumber;
    /**
     * The FullRegNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FullRegNumber;
    /**
     * The RegNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RegNumber;
    /**
     * Constructor method for RegistrationNumber
     * @uses RegistrationNumber::setPrefix()
     * @uses RegistrationNumber::setUniqueRegNumber()
     * @uses RegistrationNumber::setFullRegNumber()
     * @uses RegistrationNumber::setRegNumber()
     * @param string $prefix
     * @param string $uniqueRegNumber
     * @param string $fullRegNumber
     * @param string $regNumber
     */
    public function __construct($prefix = null, $uniqueRegNumber = null, $fullRegNumber = null, $regNumber = null)
    {
        $this
            ->setPrefix($prefix)
            ->setUniqueRegNumber($uniqueRegNumber)
            ->setFullRegNumber($fullRegNumber)
            ->setRegNumber($regNumber);
    }
    /**
     * Get Prefix value
     * @return string|null
     */
    public function getPrefix()
    {
        return $this->Prefix;
    }
    /**
     * Set Prefix value
     * @param string $prefix
     * @return \StructType\RegistrationNumber
     */
    public function setPrefix($prefix = null)
    {
        // validation for constraint: string
        if (!is_null($prefix) && !is_string($prefix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prefix)), __LINE__);
        }
        $this->Prefix = $prefix;
        return $this;
    }
    /**
     * Get UniqueRegNumber value
     * @return string|null
     */
    public function getUniqueRegNumber()
    {
        return $this->UniqueRegNumber;
    }
    /**
     * Set UniqueRegNumber value
     * @param string $uniqueRegNumber
     * @return \StructType\RegistrationNumber
     */
    public function setUniqueRegNumber($uniqueRegNumber = null)
    {
        // validation for constraint: string
        if (!is_null($uniqueRegNumber) && !is_string($uniqueRegNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uniqueRegNumber)), __LINE__);
        }
        $this->UniqueRegNumber = $uniqueRegNumber;
        return $this;
    }
    /**
     * Get FullRegNumber value
     * @return string|null
     */
    public function getFullRegNumber()
    {
        return $this->FullRegNumber;
    }
    /**
     * Set FullRegNumber value
     * @param string $fullRegNumber
     * @return \StructType\RegistrationNumber
     */
    public function setFullRegNumber($fullRegNumber = null)
    {
        // validation for constraint: string
        if (!is_null($fullRegNumber) && !is_string($fullRegNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fullRegNumber)), __LINE__);
        }
        $this->FullRegNumber = $fullRegNumber;
        return $this;
    }
    /**
     * Get RegNumber value
     * @return string|null
     */
    public function getRegNumber()
    {
        return $this->RegNumber;
    }
    /**
     * Set RegNumber value
     * @param string $regNumber
     * @return \StructType\RegistrationNumber
     */
    public function setRegNumber($regNumber = null)
    {
        // validation for constraint: string
        if (!is_null($regNumber) && !is_string($regNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regNumber)), __LINE__);
        }
        $this->RegNumber = $regNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegistrationNumber
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
