<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestPrintoutWithStamp StructType
 * @subpackage Structs
 */
class RequestPrintoutWithStamp extends AbstractStructBase
{
    /**
     * The showSearchInsureStamp
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $showSearchInsureStamp;
    /**
     * The request
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PrintoutRequest
     */
    public $request;
    /**
     * Constructor method for RequestPrintoutWithStamp
     * @uses RequestPrintoutWithStamp::setShowSearchInsureStamp()
     * @uses RequestPrintoutWithStamp::setRequest()
     * @param bool $showSearchInsureStamp
     * @param \StructType\PrintoutRequest $request
     */
    public function __construct($showSearchInsureStamp = null, \StructType\PrintoutRequest $request = null)
    {
        $this
            ->setShowSearchInsureStamp($showSearchInsureStamp)
            ->setRequest($request);
    }
    /**
     * Get showSearchInsureStamp value
     * @return bool
     */
    public function getShowSearchInsureStamp()
    {
        return $this->showSearchInsureStamp;
    }
    /**
     * Set showSearchInsureStamp value
     * @param bool $showSearchInsureStamp
     * @return \StructType\RequestPrintoutWithStamp
     */
    public function setShowSearchInsureStamp($showSearchInsureStamp = null)
    {
        // validation for constraint: boolean
        if (!is_null($showSearchInsureStamp) && !is_bool($showSearchInsureStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showSearchInsureStamp)), __LINE__);
        }
        $this->showSearchInsureStamp = $showSearchInsureStamp;
        return $this;
    }
    /**
     * Get request value
     * @return \StructType\PrintoutRequest|null
     */
    public function getRequest()
    {
        return $this->request;
    }
    /**
     * Set request value
     * @param \StructType\PrintoutRequest $request
     * @return \StructType\RequestPrintoutWithStamp
     */
    public function setRequest(\StructType\PrintoutRequest $request = null)
    {
        $this->request = $request;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RequestPrintoutWithStamp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
