<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TokenCredentials StructType
 * Meta informations extracted from the WSDL
 * - type: tns:TokenCredentials
 * @subpackage Structs
 */
class TokenCredentials extends AbstractStructBase
{
    /**
     * The SerializedToken
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SerializedToken;
    /**
     * The Requester
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Requester;
    /**
     * Constructor method for TokenCredentials
     * @uses TokenCredentials::setSerializedToken()
     * @uses TokenCredentials::setRequester()
     * @param string $serializedToken
     * @param string $requester
     */
    public function __construct($serializedToken = null, $requester = null)
    {
        $this
            ->setSerializedToken($serializedToken)
            ->setRequester($requester);
    }
    /**
     * Get SerializedToken value
     * @return string|null
     */
    public function getSerializedToken()
    {
        return $this->SerializedToken;
    }
    /**
     * Set SerializedToken value
     * @param string $serializedToken
     * @return \StructType\TokenCredentials
     */
    public function setSerializedToken($serializedToken = null)
    {
        // validation for constraint: string
        if (!is_null($serializedToken) && !is_string($serializedToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serializedToken)), __LINE__);
        }
        $this->SerializedToken = $serializedToken;
        return $this;
    }
    /**
     * Get Requester value
     * @return string|null
     */
    public function getRequester()
    {
        return $this->Requester;
    }
    /**
     * Set Requester value
     * @param string $requester
     * @return \StructType\TokenCredentials
     */
    public function setRequester($requester = null)
    {
        // validation for constraint: string
        if (!is_null($requester) && !is_string($requester)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requester)), __LINE__);
        }
        $this->Requester = $requester;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TokenCredentials
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
